/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with forlan_yy_ or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "forlangrm.y"

/* This file is part of Eclat.
   Copyright (C) 2012-2018 Sergey Poznyakoff.
 
   Eclat is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.
 
   Eclat is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with Eclat.  If not, see <http://www.gnu.org/licenses/>. */

#include "libeclat.h"
#include <grecs.h>
#include <grecs/locus.h>
#include "forlangrm.h"
#include "forlan.h"
#include <string.h>

int forlan_yy_lex();	
static int forlan_yy_error(char const *);
union forlan_node *forlan_parse_tree;
size_t forlan_variable_count;
static struct grecs_symtab *forlan_symtab;

static size_t find_variable(const char *name);
static union forlan_node *create_comp_node(union forlan_node *root,
					   struct grecs_list *arglist,
					   int wildcards);

struct path_component {
	char *id;
	char *label;
};


/* Line 371 of yacc.c  */
#line 110 "forlangrm.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_FORLANGRM_H_INCLUDED
# define YY_YY_FORLANGRM_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int forlan_yy_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum forlan_yy_tokentype {
     STRING = 258,
     IDENT = 259,
     LAST = 260,
     IF = 261,
     ELSE = 262,
     LET = 263,
     FOR = 264,
     IN = 265,
     BREAK = 266,
     CONTINUE = 267,
     STOP = 268,
     OR = 269,
     AND = 270,
     NE = 271,
     EQ = 272,
     NOT = 273
   };
#endif
/* Tokens.  */
#define STRING 258
#define IDENT 259
#define LAST 260
#define IF 261
#define ELSE 262
#define LET 263
#define FOR 264
#define IN 265
#define BREAK 266
#define CONTINUE 267
#define STOP 268
#define OR 269
#define AND 270
#define NE 271
#define EQ 272
#define NOT 273



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 45 "forlangrm.y"

	char *string;
	union forlan_node *node;
	struct grecs_list *list;
	struct {
		struct path_component *comp;
		int wildcard;
	} comp;
	struct {
		int wildcards;
		struct grecs_list *list;
	} complist;


/* Line 387 of yacc.c  */
#line 204 "forlangrm.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define forlan_yy_stype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define forlan_yy_ltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif

extern YYSTYPE forlan_yy_lval;
extern YYLTYPE forlan_yy_lloc;
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int forlan_yy_parse (void *YYPARSE_PARAM);
#else
int forlan_yy_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int forlan_yy_parse (void);
#else
int forlan_yy_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_FORLANGRM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 245 "forlangrm.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 forlan_yy_type_uint8;
#else
typedef unsigned char forlan_yy_type_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 forlan_yy_type_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char forlan_yy_type_int8;
#else
typedef short int forlan_yy_type_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 forlan_yy_type_uint16;
#else
typedef unsigned short int forlan_yy_type_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 forlan_yy_type_int16;
#else
typedef short int forlan_yy_type_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int forlan_yy_i)
#else
static int
YYID (forlan_yy_i)
    int forlan_yy_i;
#endif
{
  return forlan_yy_i;
}
#endif

#if ! defined forlan_yy_overflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined forlan_yy_overflow || YYERROR_VERBOSE */


#if (! defined forlan_yy_overflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union forlan_yy_alloc
{
  forlan_yy_type_int16 forlan_yy_ss_alloc;
  YYSTYPE forlan_yy_vs_alloc;
  YYLTYPE forlan_yy_ls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union forlan_yy_alloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (forlan_yy_type_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T forlan_yy_newbytes;						\
	YYCOPY (&forlan_yy_ptr->Stack_alloc, Stack, forlan_yy_size);			\
	Stack = &forlan_yy_ptr->Stack_alloc;					\
	forlan_yy_newbytes = forlan_yy_stacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	forlan_yy_ptr += forlan_yy_newbytes / sizeof (*forlan_yy_ptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T forlan_yy_i;                         \
          for (forlan_yy_i = 0; forlan_yy_i < (Count); forlan_yy_i++)   \
            (Dst)[forlan_yy_i] = (Src)[forlan_yy_i];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  39
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   98

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  31
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  21
/* YYNRULES -- Number of rules.  */
#define YYNRULES  52
/* YYNRULES -- Number of states.  */
#define YYNSTATES  91

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   273

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? forlan_yy_translate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const forlan_yy_type_uint8 forlan_yy_translate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    26,     2,     2,
      21,    22,    27,     2,    28,     2,    23,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    29,
       2,    30,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    24,     2,    25,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    19,     2,    20,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const forlan_yy_type_uint8 forlan_yy_prhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    16,    18,
      20,    22,    24,    28,    32,    38,    40,    42,    46,    50,
      53,    57,    61,    65,    67,    71,    74,    76,    78,    82,
      84,    89,    91,    93,    95,    97,   101,   106,   108,   110,
     112,   114,   116,   120,   122,   125,   129,   135,   141,   149,
     152,   155,   158
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const forlan_yy_type_int8 forlan_yy_rhs[] =
{
      32,     0,    -1,    33,    -1,    34,    -1,    33,    34,    -1,
      36,    -1,    47,    -1,    35,    -1,    48,    -1,    51,    -1,
      49,    -1,    50,    -1,    19,    33,    20,    -1,     6,    37,
      34,    -1,     6,    37,    34,     7,    34,    -1,    38,    -1,
      39,    -1,    38,    15,    38,    -1,    38,    14,    38,    -1,
      18,    38,    -1,    39,    17,    39,    -1,    39,    16,    39,
      -1,    21,    38,    22,    -1,    44,    -1,    44,    23,    40,
      -1,    23,    40,    -1,    23,    -1,    41,    -1,    40,    23,
      41,    -1,     4,    -1,     4,    24,    42,    25,    -1,    26,
      -1,    27,    -1,     4,    -1,     3,    -1,     4,    21,    22,
      -1,     4,    21,    45,    22,    -1,    43,    -1,     5,    -1,
       3,    -1,     4,    -1,    46,    -1,    45,    28,    46,    -1,
      39,    -1,    43,    29,    -1,     8,     4,    29,    -1,     8,
       4,    30,    39,    29,    -1,     8,     4,    30,    43,    29,
      -1,     9,    21,     4,    10,    39,    22,    34,    -1,    11,
      29,    -1,    12,    29,    -1,    13,    29,    -1,     4,    30,
      39,    29,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const forlan_yy_type_uint16 forlan_yy_rline[] =
{
       0,    75,    75,    81,    86,    93,    94,    95,    96,    97,
      98,    99,   102,   108,   115,   124,   127,   133,   140,   147,
     153,   160,   167,   173,   174,   178,   182,   188,   194,   202,
     208,   215,   221,   229,   230,   233,   255,   287,   288,   292,
     297,   305,   310,   317,   320,   323,   327,   333,   341,   351,
     355,   359,   365
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const forlan_yy_tname[] =
{
  "$end", "error", "$undefined", "STRING", "IDENT", "LAST", "IF", "ELSE",
  "LET", "FOR", "IN", "BREAK", "CONTINUE", "STOP", "OR", "AND", "NE", "EQ",
  "NOT", "'{'", "'}'", "'('", "')'", "'.'", "'['", "']'", "'%'", "'*'",
  "','", "';'", "'='", "$accept", "input", "stmtlist", "stmt", "stmt_blk",
  "stmt_cond", "cond", "bool", "node", "complist", "comp", "string",
  "funcall", "rval", "arglist", "arg", "stmt_expr", "stmt_let", "stmt_for",
  "stmt_ctrl", "stmt_asgn", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const forlan_yy_type_uint16 forlan_yy_toknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   123,
     125,    40,    41,    46,    91,    93,    37,    42,    44,    59,
      61
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const forlan_yy_type_uint8 forlan_yy_r1[] =
{
       0,    31,    32,    33,    33,    34,    34,    34,    34,    34,
      34,    34,    35,    36,    36,    37,    38,    38,    38,    38,
      38,    38,    38,    39,    39,    39,    39,    40,    40,    41,
      41,    41,    41,    42,    42,    43,    43,    44,    44,    44,
      44,    45,    45,    46,    47,    48,    48,    48,    49,    50,
      50,    50,    51
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const forlan_yy_type_uint8 forlan_yy_r2[] =
{
       0,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     5,     1,     1,     3,     3,     2,
       3,     3,     3,     1,     3,     2,     1,     1,     3,     1,
       4,     1,     1,     1,     1,     3,     4,     1,     1,     1,
       1,     1,     3,     1,     2,     3,     5,     5,     7,     2,
       2,     2,     4
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const forlan_yy_type_uint8 forlan_yy_defact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     3,     7,     5,     0,     6,     8,    10,    11,     9,
       0,     0,    39,    40,    38,     0,     0,    26,     0,    15,
      16,    37,    23,     0,     0,    49,    50,    51,     0,     1,
       4,    44,    35,    43,     0,    41,     0,    19,     0,    29,
      31,    32,    25,    27,    13,     0,     0,     0,     0,     0,
      45,     0,     0,    12,    36,     0,    52,    22,     0,     0,
       0,    18,    17,    21,    20,    24,     0,    37,     0,    42,
      34,    33,     0,    28,    14,    46,    47,     0,    30,     0,
      48
};

/* YYDEFGOTO[NTERM-NUM].  */
static const forlan_yy_type_int8 forlan_yy_defgoto[] =
{
      -1,     9,    10,    11,    12,    13,    28,    29,    30,    52,
      53,    82,    31,    32,    44,    45,    15,    16,    17,    18,
      19
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -23
static const forlan_yy_type_int8 forlan_yy_pact[] =
{
      63,    47,     8,     3,    -7,   -10,    -4,    -2,    63,    32,
      63,   -23,   -23,   -23,    26,   -23,   -23,   -23,   -23,   -23,
      13,    36,   -23,    16,   -23,     8,     8,    -3,    63,     7,
      31,   -23,    37,    49,    62,   -23,   -23,   -23,    45,   -23,
     -23,   -23,   -23,   -23,   -13,   -23,    44,   -23,    30,    56,
     -23,   -23,    64,   -23,    78,     8,     8,    36,    36,    -3,
     -23,    36,    76,   -23,   -23,    36,   -23,   -23,    80,    -3,
      63,    73,   -23,   -23,   -23,    64,    61,    65,    36,   -23,
     -23,   -23,    66,   -23,   -23,   -23,   -23,    70,   -23,    63,
     -23
};

/* YYPGOTO[NTERM-NUM].  */
static const forlan_yy_type_int8 forlan_yy_pgoto[] =
{
     -23,   -23,    85,    -8,   -23,   -23,   -23,   -22,   -15,    38,
      27,   -23,     0,   -23,   -23,    33,   -23,   -23,   -23,   -23,
     -23
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const forlan_yy_type_uint8 forlan_yy_table[] =
{
      14,    49,    40,    47,    48,    43,    46,    33,    14,    64,
      14,    22,    23,    24,    34,    65,    22,    23,    24,    35,
      54,    55,    56,    50,    51,    36,    25,    37,    14,    26,
      40,    27,    39,    71,    72,    42,    27,    20,    14,    22,
      23,    24,    73,    74,    55,    56,    76,    57,    58,     1,
      43,     2,    67,     3,     4,    41,     5,     6,     7,    27,
      59,    77,    84,    87,     8,    63,    62,     1,    20,     2,
      14,     3,     4,    66,     5,     6,     7,    21,    60,    61,
      68,    90,     8,    80,    81,    70,    78,    69,    56,    14,
      85,    88,    89,    38,    86,     0,    83,    75,    79
};

#define forlan_yy_pact_value_is_default(Yystate) \
  (!!((Yystate) == (-23)))

#define forlan_yy_table_value_is_error(Yytable_value) \
  YYID (0)

static const forlan_yy_type_int8 forlan_yy_check[] =
{
       0,     4,    10,    25,    26,    20,    21,     4,     8,    22,
      10,     3,     4,     5,    21,    28,     3,     4,     5,    29,
      28,    14,    15,    26,    27,    29,    18,    29,    28,    21,
      38,    23,     0,    55,    56,    22,    23,    21,    38,     3,
       4,     5,    57,    58,    14,    15,    61,    16,    17,     4,
      65,     6,    22,     8,     9,    29,    11,    12,    13,    23,
      23,    61,    70,    78,    19,    20,     4,     4,    21,     6,
      70,     8,     9,    29,    11,    12,    13,    30,    29,    30,
      24,    89,    19,     3,     4,     7,    10,    23,    15,    89,
      29,    25,    22,     8,    29,    -1,    69,    59,    65
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const forlan_yy_type_uint8 forlan_yy_stos[] =
{
       0,     4,     6,     8,     9,    11,    12,    13,    19,    32,
      33,    34,    35,    36,    43,    47,    48,    49,    50,    51,
      21,    30,     3,     4,     5,    18,    21,    23,    37,    38,
      39,    43,    44,     4,    21,    29,    29,    29,    33,     0,
      34,    29,    22,    39,    45,    46,    39,    38,    38,     4,
      26,    27,    40,    41,    34,    14,    15,    16,    17,    23,
      29,    30,     4,    20,    22,    28,    29,    22,    24,    23,
       7,    38,    38,    39,    39,    40,    39,    43,    10,    46,
       3,     4,    42,    41,    34,    29,    29,    39,    25,    22,
      34
};

#define forlan_yy_errok		(forlan_yy_errstatus = 0)
#define forlan_yy_clearin	(forlan_yy_char = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto forlan_yy_acceptlab
#define YYABORT		goto forlan_yy_abortlab
#define YYERROR		goto forlan_yy_errorlab


/* Like YYERROR except do call forlan_yy_error.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto forlan_yy_errlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!forlan_yy_errstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (forlan_yy_char == YYEMPTY)                                        \
    {                                                           \
      forlan_yy_char = (Token);                                         \
      forlan_yy_lval = (Value);                                         \
      YYPOPSTACK (forlan_yy_len);                                       \
      forlan_yy_state = *forlan_yy_ssp;                                         \
      goto forlan_yy_backup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      forlan_yy_error (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
forlan_yy__location_print_ (FILE *forlan_yy_o, YYLTYPE const * const forlan_yy_locp)
#else
static unsigned
forlan_yy__location_print_ (forlan_yy_o, forlan_yy_locp)
    FILE *forlan_yy_o;
    YYLTYPE const * const forlan_yy_locp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != forlan_yy_locp->last_column ? forlan_yy_locp->last_column - 1 : 0;
  if (0 <= forlan_yy_locp->first_line)
    {
      res += fprintf (forlan_yy_o, "%d", forlan_yy_locp->first_line);
      if (0 <= forlan_yy_locp->first_column)
        res += fprintf (forlan_yy_o, ".%d", forlan_yy_locp->first_column);
    }
  if (0 <= forlan_yy_locp->last_line)
    {
      if (forlan_yy_locp->first_line < forlan_yy_locp->last_line)
        {
          res += fprintf (forlan_yy_o, "-%d", forlan_yy_locp->last_line);
          if (0 <= end_col)
            res += fprintf (forlan_yy_o, ".%d", end_col);
        }
      else if (0 <= end_col && forlan_yy_locp->first_column < end_col)
        res += fprintf (forlan_yy_o, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  forlan_yy__location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `forlan_yy_lex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX forlan_yy_lex (YYLEX_PARAM)
#else
# define YYLEX forlan_yy_lex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (forlan_yy_debug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (forlan_yy_debug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      forlan_yy__symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
forlan_yy__symbol_value_print (FILE *forlan_yy_output, int forlan_yy_type, YYSTYPE const * const forlan_yy_valuep, YYLTYPE const * const forlan_yy_locationp)
#else
static void
forlan_yy__symbol_value_print (forlan_yy_output, forlan_yy_type, forlan_yy_valuep, forlan_yy_locationp)
    FILE *forlan_yy_output;
    int forlan_yy_type;
    YYSTYPE const * const forlan_yy_valuep;
    YYLTYPE const * const forlan_yy_locationp;
#endif
{
  FILE *forlan_yy_o = forlan_yy_output;
  YYUSE (forlan_yy_o);
  if (!forlan_yy_valuep)
    return;
  YYUSE (forlan_yy_locationp);
# ifdef YYPRINT
  if (forlan_yy_type < YYNTOKENS)
    YYPRINT (forlan_yy_output, forlan_yy_toknum[forlan_yy_type], *forlan_yy_valuep);
# else
  YYUSE (forlan_yy_output);
# endif
  switch (forlan_yy_type)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
forlan_yy__symbol_print (FILE *forlan_yy_output, int forlan_yy_type, YYSTYPE const * const forlan_yy_valuep, YYLTYPE const * const forlan_yy_locationp)
#else
static void
forlan_yy__symbol_print (forlan_yy_output, forlan_yy_type, forlan_yy_valuep, forlan_yy_locationp)
    FILE *forlan_yy_output;
    int forlan_yy_type;
    YYSTYPE const * const forlan_yy_valuep;
    YYLTYPE const * const forlan_yy_locationp;
#endif
{
  if (forlan_yy_type < YYNTOKENS)
    YYFPRINTF (forlan_yy_output, "token %s (", forlan_yy_tname[forlan_yy_type]);
  else
    YYFPRINTF (forlan_yy_output, "nterm %s (", forlan_yy_tname[forlan_yy_type]);

  YY_LOCATION_PRINT (forlan_yy_output, *forlan_yy_locationp);
  YYFPRINTF (forlan_yy_output, ": ");
  forlan_yy__symbol_value_print (forlan_yy_output, forlan_yy_type, forlan_yy_valuep, forlan_yy_locationp);
  YYFPRINTF (forlan_yy_output, ")");
}

/*------------------------------------------------------------------.
| forlan_yy__stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
forlan_yy__stack_print (forlan_yy_type_int16 *forlan_yy_bottom, forlan_yy_type_int16 *forlan_yy_top)
#else
static void
forlan_yy__stack_print (forlan_yy_bottom, forlan_yy_top)
    forlan_yy_type_int16 *forlan_yy_bottom;
    forlan_yy_type_int16 *forlan_yy_top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; forlan_yy_bottom <= forlan_yy_top; forlan_yy_bottom++)
    {
      int forlan_yy_bot = *forlan_yy_bottom;
      YYFPRINTF (stderr, " %d", forlan_yy_bot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (forlan_yy_debug)							\
    forlan_yy__stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
forlan_yy__reduce_print (YYSTYPE *forlan_yy_vsp, YYLTYPE *forlan_yy_lsp, int forlan_yy_rule)
#else
static void
forlan_yy__reduce_print (forlan_yy_vsp, forlan_yy_lsp, forlan_yy_rule)
    YYSTYPE *forlan_yy_vsp;
    YYLTYPE *forlan_yy_lsp;
    int forlan_yy_rule;
#endif
{
  int forlan_yy_nrhs = forlan_yy_r2[forlan_yy_rule];
  int forlan_yy_i;
  unsigned long int forlan_yy_lno = forlan_yy_rline[forlan_yy_rule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     forlan_yy_rule - 1, forlan_yy_lno);
  /* The symbols being reduced.  */
  for (forlan_yy_i = 0; forlan_yy_i < forlan_yy_nrhs; forlan_yy_i++)
    {
      YYFPRINTF (stderr, "   $%d = ", forlan_yy_i + 1);
      forlan_yy__symbol_print (stderr, forlan_yy_rhs[forlan_yy_prhs[forlan_yy_rule] + forlan_yy_i],
		       &(forlan_yy_vsp[(forlan_yy_i + 1) - (forlan_yy_nrhs)])
		       , &(forlan_yy_lsp[(forlan_yy_i + 1) - (forlan_yy_nrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (forlan_yy_debug)				\
    forlan_yy__reduce_print (forlan_yy_vsp, forlan_yy_lsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int forlan_yy_debug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef forlan_yy_strlen
#  if defined __GLIBC__ && defined _STRING_H
#   define forlan_yy_strlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
forlan_yy_strlen (const char *forlan_yy_str)
#else
static YYSIZE_T
forlan_yy_strlen (forlan_yy_str)
    const char *forlan_yy_str;
#endif
{
  YYSIZE_T forlan_yy_len;
  for (forlan_yy_len = 0; forlan_yy_str[forlan_yy_len]; forlan_yy_len++)
    continue;
  return forlan_yy_len;
}
#  endif
# endif

# ifndef forlan_yy_stpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define forlan_yy_stpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
forlan_yy_stpcpy (char *forlan_yy_dest, const char *forlan_yy_src)
#else
static char *
forlan_yy_stpcpy (forlan_yy_dest, forlan_yy_src)
    char *forlan_yy_dest;
    const char *forlan_yy_src;
#endif
{
  char *forlan_yy_d = forlan_yy_dest;
  const char *forlan_yy_s = forlan_yy_src;

  while ((*forlan_yy_d++ = *forlan_yy_s++) != '\0')
    continue;

  return forlan_yy_d - 1;
}
#  endif
# endif

# ifndef forlan_yy_tnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for forlan_yy_error.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from forlan_yy_tname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
forlan_yy_tnamerr (char *forlan_yy_res, const char *forlan_yy_str)
{
  if (*forlan_yy_str == '"')
    {
      YYSIZE_T forlan_yy_n = 0;
      char const *forlan_yy_p = forlan_yy_str;

      for (;;)
	switch (*++forlan_yy_p)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++forlan_yy_p != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (forlan_yy_res)
	      forlan_yy_res[forlan_yy_n] = *forlan_yy_p;
	    forlan_yy_n++;
	    break;

	  case '"':
	    if (forlan_yy_res)
	      forlan_yy_res[forlan_yy_n] = '\0';
	    return forlan_yy_n;
	  }
    do_not_strip_quotes: ;
    }

  if (! forlan_yy_res)
    return forlan_yy_strlen (forlan_yy_str);

  return forlan_yy_stpcpy (forlan_yy_res, forlan_yy_str) - forlan_yy_res;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
forlan_yy_syntax_error (YYSIZE_T *forlan_yy_msg_alloc, char **forlan_yy_msg,
                forlan_yy_type_int16 *forlan_yy_ssp, int forlan_yy_token)
{
  YYSIZE_T forlan_yy_size0 = forlan_yy_tnamerr (YY_NULL, forlan_yy_tname[forlan_yy_token]);
  YYSIZE_T forlan_yy_size = forlan_yy_size0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *forlan_yy_format = YY_NULL;
  /* Arguments of forlan_yy_format. */
  char const *forlan_yy_arg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int forlan_yy_count = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in forlan_yy_char) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated forlan_yy_char.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (forlan_yy_token != YYEMPTY)
    {
      int forlan_yy_n = forlan_yy_pact[*forlan_yy_ssp];
      forlan_yy_arg[forlan_yy_count++] = forlan_yy_tname[forlan_yy_token];
      if (!forlan_yy_pact_value_is_default (forlan_yy_n))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int forlan_yy_xbegin = forlan_yy_n < 0 ? -forlan_yy_n : 0;
          /* Stay within bounds of both forlan_yy_check and forlan_yy_tname.  */
          int forlan_yy_checklim = YYLAST - forlan_yy_n + 1;
          int forlan_yy_xend = forlan_yy_checklim < YYNTOKENS ? forlan_yy_checklim : YYNTOKENS;
          int forlan_yy_x;

          for (forlan_yy_x = forlan_yy_xbegin; forlan_yy_x < forlan_yy_xend; ++forlan_yy_x)
            if (forlan_yy_check[forlan_yy_x + forlan_yy_n] == forlan_yy_x && forlan_yy_x != YYTERROR
                && !forlan_yy_table_value_is_error (forlan_yy_table[forlan_yy_x + forlan_yy_n]))
              {
                if (forlan_yy_count == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    forlan_yy_count = 1;
                    forlan_yy_size = forlan_yy_size0;
                    break;
                  }
                forlan_yy_arg[forlan_yy_count++] = forlan_yy_tname[forlan_yy_x];
                {
                  YYSIZE_T forlan_yy_size1 = forlan_yy_size + forlan_yy_tnamerr (YY_NULL, forlan_yy_tname[forlan_yy_x]);
                  if (! (forlan_yy_size <= forlan_yy_size1
                         && forlan_yy_size1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  forlan_yy_size = forlan_yy_size1;
                }
              }
        }
    }

  switch (forlan_yy_count)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        forlan_yy_format = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T forlan_yy_size1 = forlan_yy_size + forlan_yy_strlen (forlan_yy_format);
    if (! (forlan_yy_size <= forlan_yy_size1 && forlan_yy_size1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    forlan_yy_size = forlan_yy_size1;
  }

  if (*forlan_yy_msg_alloc < forlan_yy_size)
    {
      *forlan_yy_msg_alloc = 2 * forlan_yy_size;
      if (! (forlan_yy_size <= *forlan_yy_msg_alloc
             && *forlan_yy_msg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *forlan_yy_msg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *forlan_yy_p = *forlan_yy_msg;
    int forlan_yy_i = 0;
    while ((*forlan_yy_p = *forlan_yy_format) != '\0')
      if (*forlan_yy_p == '%' && forlan_yy_format[1] == 's' && forlan_yy_i < forlan_yy_count)
        {
          forlan_yy_p += forlan_yy_tnamerr (forlan_yy_p, forlan_yy_arg[forlan_yy_i++]);
          forlan_yy_format += 2;
        }
      else
        {
          forlan_yy_p++;
          forlan_yy_format++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
forlan_yy_destruct (const char *forlan_yy_msg, int forlan_yy_type, YYSTYPE *forlan_yy_valuep, YYLTYPE *forlan_yy_locationp)
#else
static void
forlan_yy_destruct (forlan_yy_msg, forlan_yy_type, forlan_yy_valuep, forlan_yy_locationp)
    const char *forlan_yy_msg;
    int forlan_yy_type;
    YYSTYPE *forlan_yy_valuep;
    YYLTYPE *forlan_yy_locationp;
#endif
{
  YYUSE (forlan_yy_valuep);
  YYUSE (forlan_yy_locationp);

  if (!forlan_yy_msg)
    forlan_yy_msg = "Deleting";
  YY_SYMBOL_PRINT (forlan_yy_msg, forlan_yy_type, forlan_yy_valuep, forlan_yy_locationp);

  switch (forlan_yy_type)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int forlan_yy_char;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE forlan_yy_lval YY_INITIAL_VALUE(forlan_yy_val_default);

/* Location data for the lookahead symbol.  */
YYLTYPE forlan_yy_lloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;


/* Number of syntax errors so far.  */
int forlan_yy_nerrs;


/*----------.
| forlan_yy_parse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
forlan_yy_parse (void *YYPARSE_PARAM)
#else
int
forlan_yy_parse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
forlan_yy_parse (void)
#else
int
forlan_yy_parse ()

#endif
#endif
{
    int forlan_yy_state;
    /* Number of tokens to shift before error messages enabled.  */
    int forlan_yy_errstatus;

    /* The stacks and their tools:
       `forlan_yy_ss': related to states.
       `forlan_yy_vs': related to semantic values.
       `forlan_yy_ls': related to locations.

       Refer to the stacks through separate pointers, to allow forlan_yy_overflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    forlan_yy_type_int16 forlan_yy_ssa[YYINITDEPTH];
    forlan_yy_type_int16 *forlan_yy_ss;
    forlan_yy_type_int16 *forlan_yy_ssp;

    /* The semantic value stack.  */
    YYSTYPE forlan_yy_vsa[YYINITDEPTH];
    YYSTYPE *forlan_yy_vs;
    YYSTYPE *forlan_yy_vsp;

    /* The location stack.  */
    YYLTYPE forlan_yy_lsa[YYINITDEPTH];
    YYLTYPE *forlan_yy_ls;
    YYLTYPE *forlan_yy_lsp;

    /* The locations where the error started and ended.  */
    YYLTYPE forlan_yy_error_range[3];

    YYSIZE_T forlan_yy_stacksize;

  int forlan_yy_n;
  int forlan_yy_result;
  /* Lookahead token as an internal (translated) token number.  */
  int forlan_yy_token = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE forlan_yy_val;
  YYLTYPE forlan_yy_loc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char forlan_yy_msgbuf[128];
  char *forlan_yy_msg = forlan_yy_msgbuf;
  YYSIZE_T forlan_yy_msg_alloc = sizeof forlan_yy_msgbuf;
#endif

#define YYPOPSTACK(N)   (forlan_yy_vsp -= (N), forlan_yy_ssp -= (N), forlan_yy_lsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int forlan_yy_len = 0;

  forlan_yy_ssp = forlan_yy_ss = forlan_yy_ssa;
  forlan_yy_vsp = forlan_yy_vs = forlan_yy_vsa;
  forlan_yy_lsp = forlan_yy_ls = forlan_yy_lsa;
  forlan_yy_stacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  forlan_yy_state = 0;
  forlan_yy_errstatus = 0;
  forlan_yy_nerrs = 0;
  forlan_yy_char = YYEMPTY; /* Cause a token to be read.  */
  forlan_yy_lsp[0] = forlan_yy_lloc;
  goto forlan_yy_setstate;

/*------------------------------------------------------------.
| forlan_yy_newstate -- Push a new state, which is found in forlan_yy_state.  |
`------------------------------------------------------------*/
 forlan_yy_newstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  forlan_yy_ssp++;

 forlan_yy_setstate:
  *forlan_yy_ssp = forlan_yy_state;

  if (forlan_yy_ss + forlan_yy_stacksize - 1 <= forlan_yy_ssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T forlan_yy_size = forlan_yy_ssp - forlan_yy_ss + 1;

#ifdef forlan_yy_overflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *forlan_yy_vs1 = forlan_yy_vs;
	forlan_yy_type_int16 *forlan_yy_ss1 = forlan_yy_ss;
	YYLTYPE *forlan_yy_ls1 = forlan_yy_ls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if forlan_yy_overflow is a macro.  */
	forlan_yy_overflow (YY_("memory exhausted"),
		    &forlan_yy_ss1, forlan_yy_size * sizeof (*forlan_yy_ssp),
		    &forlan_yy_vs1, forlan_yy_size * sizeof (*forlan_yy_vsp),
		    &forlan_yy_ls1, forlan_yy_size * sizeof (*forlan_yy_lsp),
		    &forlan_yy_stacksize);

	forlan_yy_ls = forlan_yy_ls1;
	forlan_yy_ss = forlan_yy_ss1;
	forlan_yy_vs = forlan_yy_vs1;
      }
#else /* no forlan_yy_overflow */
# ifndef YYSTACK_RELOCATE
      goto forlan_yy_exhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= forlan_yy_stacksize)
	goto forlan_yy_exhaustedlab;
      forlan_yy_stacksize *= 2;
      if (YYMAXDEPTH < forlan_yy_stacksize)
	forlan_yy_stacksize = YYMAXDEPTH;

      {
	forlan_yy_type_int16 *forlan_yy_ss1 = forlan_yy_ss;
	union forlan_yy_alloc *forlan_yy_ptr =
	  (union forlan_yy_alloc *) YYSTACK_ALLOC (YYSTACK_BYTES (forlan_yy_stacksize));
	if (! forlan_yy_ptr)
	  goto forlan_yy_exhaustedlab;
	YYSTACK_RELOCATE (forlan_yy_ss_alloc, forlan_yy_ss);
	YYSTACK_RELOCATE (forlan_yy_vs_alloc, forlan_yy_vs);
	YYSTACK_RELOCATE (forlan_yy_ls_alloc, forlan_yy_ls);
#  undef YYSTACK_RELOCATE
	if (forlan_yy_ss1 != forlan_yy_ssa)
	  YYSTACK_FREE (forlan_yy_ss1);
      }
# endif
#endif /* no forlan_yy_overflow */

      forlan_yy_ssp = forlan_yy_ss + forlan_yy_size - 1;
      forlan_yy_vsp = forlan_yy_vs + forlan_yy_size - 1;
      forlan_yy_lsp = forlan_yy_ls + forlan_yy_size - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) forlan_yy_stacksize));

      if (forlan_yy_ss + forlan_yy_stacksize - 1 <= forlan_yy_ssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", forlan_yy_state));

  if (forlan_yy_state == YYFINAL)
    YYACCEPT;

  goto forlan_yy_backup;

/*-----------.
| forlan_yy_backup.  |
`-----------*/
forlan_yy_backup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  forlan_yy_n = forlan_yy_pact[forlan_yy_state];
  if (forlan_yy_pact_value_is_default (forlan_yy_n))
    goto forlan_yy_default;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (forlan_yy_char == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      forlan_yy_char = YYLEX;
    }

  if (forlan_yy_char <= YYEOF)
    {
      forlan_yy_char = forlan_yy_token = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      forlan_yy_token = YYTRANSLATE (forlan_yy_char);
      YY_SYMBOL_PRINT ("Next token is", forlan_yy_token, &forlan_yy_lval, &forlan_yy_lloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  forlan_yy_n += forlan_yy_token;
  if (forlan_yy_n < 0 || YYLAST < forlan_yy_n || forlan_yy_check[forlan_yy_n] != forlan_yy_token)
    goto forlan_yy_default;
  forlan_yy_n = forlan_yy_table[forlan_yy_n];
  if (forlan_yy_n <= 0)
    {
      if (forlan_yy_table_value_is_error (forlan_yy_n))
        goto forlan_yy_errlab;
      forlan_yy_n = -forlan_yy_n;
      goto forlan_yy_reduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (forlan_yy_errstatus)
    forlan_yy_errstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", forlan_yy_token, &forlan_yy_lval, &forlan_yy_lloc);

  /* Discard the shifted token.  */
  forlan_yy_char = YYEMPTY;

  forlan_yy_state = forlan_yy_n;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++forlan_yy_vsp = forlan_yy_lval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++forlan_yy_lsp = forlan_yy_lloc;
  goto forlan_yy_newstate;


/*-----------------------------------------------------------.
| forlan_yy_default -- do the default action for the current state.  |
`-----------------------------------------------------------*/
forlan_yy_default:
  forlan_yy_n = forlan_yy_defact[forlan_yy_state];
  if (forlan_yy_n == 0)
    goto forlan_yy_errlab;
  goto forlan_yy_reduce;


/*-----------------------------.
| forlan_yy_reduce -- Do a reduction.  |
`-----------------------------*/
forlan_yy_reduce:
  /* forlan_yy_n is the number of a rule to reduce with.  */
  forlan_yy_len = forlan_yy_r2[forlan_yy_n];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  forlan_yy_val = forlan_yy_vsp[1-forlan_yy_len];

  /* Default location.  */
  YYLLOC_DEFAULT (forlan_yy_loc, (forlan_yy_lsp - forlan_yy_len), forlan_yy_len);
  YY_REDUCE_PRINT (forlan_yy_n);
  switch (forlan_yy_n)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 76 "forlangrm.y"
    {
		    forlan_parse_tree = forlan_stmt_from_list((forlan_yy_vsp[(1) - (1)].list));
	    }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 82 "forlangrm.y"
    {
		    (forlan_yy_val.list) = forlan_stmt_list();
		    grecs_list_append((forlan_yy_val.list), (forlan_yy_vsp[(1) - (1)].node));
	    }
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 87 "forlangrm.y"
    {
		    grecs_list_append((forlan_yy_vsp[(1) - (2)].list), (forlan_yy_vsp[(2) - (2)].node));
		    (forlan_yy_val.list) = (forlan_yy_vsp[(1) - (2)].list);
	    }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 103 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_stmt_from_list((forlan_yy_vsp[(2) - (3)].list));
	    }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 109 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_cond);
		    (forlan_yy_val.node)->cond.expr = (forlan_yy_vsp[(2) - (3)].node);
		    (forlan_yy_val.node)->cond.iftrue = (forlan_yy_vsp[(3) - (3)].node);
		    (forlan_yy_val.node)->cond.iffalse = NULL;
	    }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 116 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_cond);
		    (forlan_yy_val.node)->cond.expr = (forlan_yy_vsp[(2) - (5)].node);
		    (forlan_yy_val.node)->cond.iftrue = (forlan_yy_vsp[(3) - (5)].node);
		    (forlan_yy_val.node)->cond.iffalse = (forlan_yy_vsp[(5) - (5)].node);
	    }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 128 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_expr);
		    (forlan_yy_val.node)->expr.opcode = forlan_opcode_node;
		    (forlan_yy_val.node)->expr.arg[0] = (forlan_yy_vsp[(1) - (1)].node);
	    }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 134 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_expr);
		    (forlan_yy_val.node)->expr.opcode = forlan_opcode_and;
		    (forlan_yy_val.node)->expr.arg[0] = (forlan_yy_vsp[(1) - (3)].node);
		    (forlan_yy_val.node)->expr.arg[1] = (forlan_yy_vsp[(3) - (3)].node);
	    }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 141 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_expr);
		    (forlan_yy_val.node)->expr.opcode = forlan_opcode_or;
		    (forlan_yy_val.node)->expr.arg[0] = (forlan_yy_vsp[(1) - (3)].node);
		    (forlan_yy_val.node)->expr.arg[1] = (forlan_yy_vsp[(3) - (3)].node);
	    }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 148 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_expr);
		    (forlan_yy_val.node)->expr.opcode = forlan_opcode_not;
		    (forlan_yy_val.node)->expr.arg[0] = (forlan_yy_vsp[(2) - (2)].node);
	    }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 154 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_expr);
		    (forlan_yy_val.node)->expr.opcode = forlan_opcode_eq;
		    (forlan_yy_val.node)->expr.arg[0] = (forlan_yy_vsp[(1) - (3)].node);
		    (forlan_yy_val.node)->expr.arg[1] = (forlan_yy_vsp[(3) - (3)].node);
	    }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 161 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_expr);
		    (forlan_yy_val.node)->expr.opcode = forlan_opcode_ne;
		    (forlan_yy_val.node)->expr.arg[0] = (forlan_yy_vsp[(1) - (3)].node);
		    (forlan_yy_val.node)->expr.arg[1] = (forlan_yy_vsp[(3) - (3)].node);
	    }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 168 "forlangrm.y"
    {
		    (forlan_yy_val.node) = (forlan_yy_vsp[(2) - (3)].node);
	    }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 175 "forlangrm.y"
    {
		    (forlan_yy_val.node) = create_comp_node((forlan_yy_vsp[(1) - (3)].node), (forlan_yy_vsp[(3) - (3)].complist).list, (forlan_yy_vsp[(3) - (3)].complist).wildcards);
            }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 179 "forlangrm.y"
    {
		    (forlan_yy_val.node) = create_comp_node(NULL, (forlan_yy_vsp[(2) - (2)].complist).list, (forlan_yy_vsp[(2) - (2)].complist).wildcards);
	    }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 183 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_comp);
	    }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 189 "forlangrm.y"
    {
		    (forlan_yy_val.complist).list = grecs_list_create();
		    grecs_list_append((forlan_yy_val.complist).list, (forlan_yy_vsp[(1) - (1)].comp).comp);
		    (forlan_yy_val.complist).wildcards = (forlan_yy_vsp[(1) - (1)].comp).wildcard;
	    }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 195 "forlangrm.y"
    {
		    grecs_list_append((forlan_yy_vsp[(1) - (3)].complist).list, (forlan_yy_vsp[(3) - (3)].comp).comp);
		    (forlan_yy_val.complist) = (forlan_yy_vsp[(1) - (3)].complist);
		    (forlan_yy_val.complist).wildcards |= (forlan_yy_vsp[(3) - (3)].comp).wildcard;
	    }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 203 "forlangrm.y"
    {
		    (forlan_yy_val.comp).comp = grecs_zalloc(sizeof(*(forlan_yy_val.comp).comp));
		    (forlan_yy_val.comp).comp->id = (forlan_yy_vsp[(1) - (1)].string);
		    (forlan_yy_val.comp).wildcard = 0;
	    }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 209 "forlangrm.y"
    {
		    (forlan_yy_val.comp).comp = grecs_zalloc(sizeof(*(forlan_yy_val.comp).comp));
		    (forlan_yy_val.comp).comp->id = (forlan_yy_vsp[(1) - (4)].string);
		    (forlan_yy_val.comp).comp->label = (forlan_yy_vsp[(3) - (4)].string);
		    (forlan_yy_val.comp).wildcard = 0;
	    }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 216 "forlangrm.y"
    {
		    (forlan_yy_val.comp).comp = grecs_zalloc(sizeof(*(forlan_yy_val.comp).comp));
		    (forlan_yy_val.comp).comp->id = grecs_strdup("%");
		    (forlan_yy_val.comp).wildcard = 1;
	    }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 222 "forlangrm.y"
    {
		    (forlan_yy_val.comp).comp = grecs_zalloc(sizeof(*(forlan_yy_val.comp).comp));
		    (forlan_yy_val.comp).comp->id = grecs_strdup("*");
		    (forlan_yy_val.comp).wildcard = 1;
	    }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 234 "forlangrm.y"
    {
		    struct forlan_function *fp =
			    forlan_find_function((forlan_yy_vsp[(1) - (3)].string));
		    if (!fp) {
			    grecs_error(&(forlan_yy_lsp[(1) - (3)]), 0,
					"call to unknown function \"%s\"",
					(forlan_yy_vsp[(1) - (3)].string));
			    YYERROR;
		    }

		    if (fp->minargs != 0) {
			    grecs_error(&(forlan_yy_lsp[(1) - (3)]), 0,
					"not enough arguments in call to \"%s\"",
					(forlan_yy_vsp[(1) - (3)].string));
			    YYERROR;
		    }
		    
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_func);
		    (forlan_yy_val.node)->func.fp = fp;
		    (forlan_yy_val.node)->func.args = NULL;
	    }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 256 "forlangrm.y"
    {
		    struct forlan_function *fp =
			    forlan_find_function((forlan_yy_vsp[(1) - (4)].string));
		    if (!fp) {
			    grecs_error(&(forlan_yy_lsp[(1) - (4)]), 0,
					"call to unknown function \"%s\"",
					(forlan_yy_vsp[(1) - (4)].string));
			    YYERROR;
		    }

		    if ((forlan_yy_vsp[(3) - (4)].list)->count < fp->minargs) {
			    grecs_error(&(forlan_yy_lsp[(1) - (4)]), 0,
					"not enough arguments in call to \"%s\"",
					(forlan_yy_vsp[(1) - (4)].string));
			    YYERROR;
		    }
		    if (fp->maxargs >= 0 && (forlan_yy_vsp[(3) - (4)].list)->count > fp->maxargs) {
			    grecs_error(&(forlan_yy_lsp[(1) - (4)]), 0,
					"too many arguments in call to \"%s\"",
					(forlan_yy_vsp[(1) - (4)].string));
			    YYERROR;
		    }

		    /* FIXME: Check data types */
		    
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_func);
		    (forlan_yy_val.node)->func.fp = fp;
		    (forlan_yy_val.node)->func.args = (forlan_yy_vsp[(3) - (4)].list);
	    }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 289 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_last);
	    }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 293 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_lit);
		    (forlan_yy_val.node)->lit.string = (forlan_yy_vsp[(1) - (1)].string);
	    }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 298 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_var);
		    (forlan_yy_val.node)->var.idx = find_variable((forlan_yy_vsp[(1) - (1)].string));
//		    free($1);
	    }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 306 "forlangrm.y"
    {
		    (forlan_yy_val.list) = forlan_stmt_list();
		    grecs_list_append((forlan_yy_val.list), (forlan_yy_vsp[(1) - (1)].node));
	    }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 311 "forlangrm.y"
    {
		    grecs_list_append((forlan_yy_vsp[(1) - (3)].list), (forlan_yy_vsp[(3) - (3)].node));
		    (forlan_yy_val.list) = (forlan_yy_vsp[(1) - (3)].list);
	    }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 324 "forlangrm.y"
    {
		    find_variable((forlan_yy_vsp[(2) - (3)].string));
	    }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 328 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_asgn);
		    (forlan_yy_val.node)->asgn.idx = find_variable((forlan_yy_vsp[(2) - (5)].string));
		    (forlan_yy_val.node)->asgn.node = (forlan_yy_vsp[(4) - (5)].node);
	    }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 334 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_asgn);
		    (forlan_yy_val.node)->asgn.idx = find_variable((forlan_yy_vsp[(2) - (5)].string));
		    (forlan_yy_val.node)->asgn.node = (forlan_yy_vsp[(4) - (5)].node);
	    }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 342 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_loop);
		    (forlan_yy_val.node)->loop.idx = find_variable((forlan_yy_vsp[(3) - (7)].string));
		    (forlan_yy_val.node)->loop.node = (forlan_yy_vsp[(5) - (7)].node);
		    (forlan_yy_val.node)->loop.stmt = (forlan_yy_vsp[(7) - (7)].node);
	    }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 352 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_break);
	    }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 356 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_continue);
	    }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 360 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_stop);
	    }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 366 "forlangrm.y"
    {
		    (forlan_yy_val.node) = forlan_node_create(forlan_type_asgn);
		    (forlan_yy_val.node)->asgn.idx = find_variable((forlan_yy_vsp[(1) - (4)].string));
		    (forlan_yy_val.node)->asgn.node = (forlan_yy_vsp[(3) - (4)].node);
	    }
    break;


/* Line 1792 of yacc.c  */
#line 2015 "forlangrm.c"
      default: break;
    }
  /* User semantic actions sometimes alter forlan_yy_char, and that requires
     that forlan_yy_token be updated with the new translation.  We take the
     approach of translating immediately before every use of forlan_yy_token.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering forlan_yy_char or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", forlan_yy_r1[forlan_yy_n], &forlan_yy_val, &forlan_yy_loc);

  YYPOPSTACK (forlan_yy_len);
  forlan_yy_len = 0;
  YY_STACK_PRINT (forlan_yy_ss, forlan_yy_ssp);

  *++forlan_yy_vsp = forlan_yy_val;
  *++forlan_yy_lsp = forlan_yy_loc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  forlan_yy_n = forlan_yy_r1[forlan_yy_n];

  forlan_yy_state = forlan_yy_pgoto[forlan_yy_n - YYNTOKENS] + *forlan_yy_ssp;
  if (0 <= forlan_yy_state && forlan_yy_state <= YYLAST && forlan_yy_check[forlan_yy_state] == *forlan_yy_ssp)
    forlan_yy_state = forlan_yy_table[forlan_yy_state];
  else
    forlan_yy_state = forlan_yy_defgoto[forlan_yy_n - YYNTOKENS];

  goto forlan_yy_newstate;


/*------------------------------------.
| forlan_yy_errlab -- here on detecting error |
`------------------------------------*/
forlan_yy_errlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  forlan_yy_token = forlan_yy_char == YYEMPTY ? YYEMPTY : YYTRANSLATE (forlan_yy_char);

  /* If not already recovering from an error, report this error.  */
  if (!forlan_yy_errstatus)
    {
      ++forlan_yy_nerrs;
#if ! YYERROR_VERBOSE
      forlan_yy_error (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR forlan_yy_syntax_error (&forlan_yy_msg_alloc, &forlan_yy_msg, \
                                        forlan_yy_ssp, forlan_yy_token)
      {
        char const *forlan_yy_msgp = YY_("syntax error");
        int forlan_yy_syntax_error_status;
        forlan_yy_syntax_error_status = YYSYNTAX_ERROR;
        if (forlan_yy_syntax_error_status == 0)
          forlan_yy_msgp = forlan_yy_msg;
        else if (forlan_yy_syntax_error_status == 1)
          {
            if (forlan_yy_msg != forlan_yy_msgbuf)
              YYSTACK_FREE (forlan_yy_msg);
            forlan_yy_msg = (char *) YYSTACK_ALLOC (forlan_yy_msg_alloc);
            if (!forlan_yy_msg)
              {
                forlan_yy_msg = forlan_yy_msgbuf;
                forlan_yy_msg_alloc = sizeof forlan_yy_msgbuf;
                forlan_yy_syntax_error_status = 2;
              }
            else
              {
                forlan_yy_syntax_error_status = YYSYNTAX_ERROR;
                forlan_yy_msgp = forlan_yy_msg;
              }
          }
        forlan_yy_error (forlan_yy_msgp);
        if (forlan_yy_syntax_error_status == 2)
          goto forlan_yy_exhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  forlan_yy_error_range[1] = forlan_yy_lloc;

  if (forlan_yy_errstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (forlan_yy_char <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (forlan_yy_char == YYEOF)
	    YYABORT;
	}
      else
	{
	  forlan_yy_destruct ("Error: discarding",
		      forlan_yy_token, &forlan_yy_lval, &forlan_yy_lloc);
	  forlan_yy_char = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto forlan_yy_errlab1;


/*---------------------------------------------------.
| forlan_yy_errorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
forlan_yy_errorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label forlan_yy_errorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto forlan_yy_errorlab;

  forlan_yy_error_range[1] = forlan_yy_lsp[1-forlan_yy_len];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (forlan_yy_len);
  forlan_yy_len = 0;
  YY_STACK_PRINT (forlan_yy_ss, forlan_yy_ssp);
  forlan_yy_state = *forlan_yy_ssp;
  goto forlan_yy_errlab1;


/*-------------------------------------------------------------.
| forlan_yy_errlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
forlan_yy_errlab1:
  forlan_yy_errstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      forlan_yy_n = forlan_yy_pact[forlan_yy_state];
      if (!forlan_yy_pact_value_is_default (forlan_yy_n))
	{
	  forlan_yy_n += YYTERROR;
	  if (0 <= forlan_yy_n && forlan_yy_n <= YYLAST && forlan_yy_check[forlan_yy_n] == YYTERROR)
	    {
	      forlan_yy_n = forlan_yy_table[forlan_yy_n];
	      if (0 < forlan_yy_n)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (forlan_yy_ssp == forlan_yy_ss)
	YYABORT;

      forlan_yy_error_range[1] = *forlan_yy_lsp;
      forlan_yy_destruct ("Error: popping",
		  forlan_yy_stos[forlan_yy_state], forlan_yy_vsp, forlan_yy_lsp);
      YYPOPSTACK (1);
      forlan_yy_state = *forlan_yy_ssp;
      YY_STACK_PRINT (forlan_yy_ss, forlan_yy_ssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++forlan_yy_vsp = forlan_yy_lval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  forlan_yy_error_range[2] = forlan_yy_lloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (forlan_yy_loc, forlan_yy_error_range, 2);
  *++forlan_yy_lsp = forlan_yy_loc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", forlan_yy_stos[forlan_yy_n], forlan_yy_vsp, forlan_yy_lsp);

  forlan_yy_state = forlan_yy_n;
  goto forlan_yy_newstate;


/*-------------------------------------.
| forlan_yy_acceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
forlan_yy_acceptlab:
  forlan_yy_result = 0;
  goto forlan_yy_return;

/*-----------------------------------.
| forlan_yy_abortlab -- YYABORT comes here.  |
`-----------------------------------*/
forlan_yy_abortlab:
  forlan_yy_result = 1;
  goto forlan_yy_return;

#if !defined forlan_yy_overflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| forlan_yy_exhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
forlan_yy_exhaustedlab:
  forlan_yy_error (YY_("memory exhausted"));
  forlan_yy_result = 2;
  /* Fall through.  */
#endif

forlan_yy_return:
  if (forlan_yy_char != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      forlan_yy_token = YYTRANSLATE (forlan_yy_char);
      forlan_yy_destruct ("Cleanup: discarding lookahead",
                  forlan_yy_token, &forlan_yy_lval, &forlan_yy_lloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (forlan_yy_len);
  YY_STACK_PRINT (forlan_yy_ss, forlan_yy_ssp);
  while (forlan_yy_ssp != forlan_yy_ss)
    {
      forlan_yy_destruct ("Cleanup: popping",
		  forlan_yy_stos[*forlan_yy_ssp], forlan_yy_vsp, forlan_yy_lsp);
      YYPOPSTACK (1);
    }
#ifndef forlan_yy_overflow
  if (forlan_yy_ss != forlan_yy_ssa)
    YYSTACK_FREE (forlan_yy_ss);
#endif
#if YYERROR_VERBOSE
  if (forlan_yy_msg != forlan_yy_msgbuf)
    YYSTACK_FREE (forlan_yy_msg);
#endif
  /* Make sure YYID is used.  */
  return YYID (forlan_yy_result);
}


/* Line 2055 of yacc.c  */
#line 372 "forlangrm.y"

static int
forlan_yy_error(char const *s)
{
	grecs_error(&forlan_yy_lloc, 0, "%s", s);
	return 0;
}
	
int
forlan_parser()
{
	forlan_yy_debug = debug_level(forlan_dbg) >= FORLAN_DBG_GRAM;
	return forlan_yy_parse();
}

forlan_eval_env_t
forlan_parse_buffer(const char *input, size_t length,
		    struct grecs_locus_point *pt)
{
	int rc;
	forlan_eval_env_t env = NULL;
	
	forlan_lex_from_buffer(input, length, pt);
	rc = forlan_parser();
	forlan_lex_end();
	grecs_symtab_free(forlan_symtab);
	forlan_symtab = NULL;

	if (rc == 0)
		env = forlan_create_environment(forlan_parse_tree,
						forlan_variable_count);

	return env;
}

forlan_eval_env_t
forlan_parse_file(FILE *fp, struct grecs_locus_point *pt)
{
	int rc;
	forlan_eval_env_t env = NULL;
	
	forlan_lex_from_file(fp, pt);
	rc = forlan_parser();
	forlan_lex_end();
	grecs_symtab_free(forlan_symtab);
	forlan_symtab = NULL;

	if (rc == 0)
		env = forlan_create_environment(forlan_parse_tree,
						forlan_variable_count);

	return env;
}

static size_t
find_variable(const char *name)
{
	struct forlan_variable key;
	struct forlan_variable *ent;
	int install = 1;

	if (!forlan_symtab) {
		forlan_symtab = grecs_symtab_create_default(
			              sizeof(struct forlan_variable));
		if (!forlan_symtab)
			grecs_alloc_die();
		forlan_variable_count = 0;
	}
  
	key.name = (char*) name;
	ent = grecs_symtab_lookup_or_install(forlan_symtab, &key, &install);
	if (!ent)
		grecs_alloc_die();
	if (install)
		ent->idx = forlan_variable_count++;
	return ent->idx;
}

/* Optimize the content of "comp" node.
   
   The grecs_match_buf_create function compresses contiguous occurrences
   of the "*" wildcard into a single one, shifting the rest of elements in
   argv and labelv into the freed slots.  This can result in changing the
   number of arguments.  We create a buffer to let it do its job and update
   the argc stored in the node, so that subsequent calls to
   grecs_match_list_create get the correct number of elements.
 */
static void
optimize_comp(union forlan_node *p)
{
	grecs_match_buf_t mb;

	mb = grecs_match_buf_create(p->comp.argc, p->comp.argv, p->comp.labelv);
	p->comp.argc = grecs_match_buf_get_args(mb, NULL);
	free(mb);
}

static union forlan_node *
create_comp_node(union forlan_node *root, struct grecs_list *arglist,
		 int wildcards)
{
	union forlan_node *ret;
	int i;
	struct grecs_list_entry *ep;
		    
	ret = forlan_node_create(forlan_type_comp);
	ret->comp.root = root;
	ret->comp.wildcards = wildcards;
	ret->comp.argc = arglist->count;
	ret->comp.argv = grecs_calloc(arglist->count,
				      sizeof(ret->comp.argv[0]));
	ret->comp.labelv = grecs_calloc(arglist->count,
					sizeof(ret->comp.labelv[0]));
	for (i = 0, ep = arglist->head; ep; i++, ep = ep->next) {
		struct path_component *comp = ep->data;
		struct grecs_value *val;

		ret->comp.argv[i] = comp->id;
		if (comp->label) {
			val = grecs_malloc(sizeof(*val));
			val->type = GRECS_TYPE_STRING;
			val->v.string = comp->label;
		} else
			val = NULL;
		ret->comp.labelv[i] = val;
	}
	grecs_list_free(arglist);
	optimize_comp(ret);
	return ret;
}
